package hatelace;

public class IntWord extends Word {
    private Integer value;

    public IntWord(Integer value) {
        this.value = value;
    }

    // public <T> T getValue() {
    //     return value;
    // }

    public Integer getValue() {
        return value;
    }

    public IntWord multiply(Word value) {
        return new IntWord(this.value * (Integer) value.getValue());
    }

    public <T> T add(Word other) {
        return (T) new IntWord(value + (Integer) other.getValue());
    }

    public <T> T subtract(Word other) {
        return (T) new IntWord(value - (Integer) other.getValue());
    }

    // public <T> T multiply(Word other) {
    //     return (T) new IntWord(value * (Integer) other.getValue());
    // }

    public <T> T divide(Word other) {
        return (T) new IntWord(value / (Integer) other.getValue());
    }
}
